﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using rfid;

namespace ReaderModeCS
{
  class ReaderModeCS
  {
    static string MakeStringFromArray(sbyte[] Arr,int StringNummer)
    {
      string strLine;
      strLine = "";

      int i = 0;
      for (int aktStringNummer = 0; aktStringNummer <= StringNummer; aktStringNummer++)
      {
        strLine = "";
        for (; (i < Arr.Length); i++)
        {
          if (Arr[i] == 0)
          {
            break;
          }
          strLine += (char)Arr[i];
        }
        i++;
        if (strLine.Length == 0)
          break;
      }
      return strLine;
    }

    static sbyte[] MakeArrayFromString(string Name)
    {
      sbyte[] arr = new sbyte[Name.Length];
      for (int i = 0; i < Name.Length; i++)
        arr[i] = (sbyte)Name[i];
      return arr;
    }

    static byte[] MakeByteArrayFromString(string Name)
    {
      byte[] arr = new byte[Name.Length];
      for (int i = 0; i < Name.Length; i++)
        arr[i] = (byte)Name[i];
      return arr;
    }

    static char cNibble(byte bVal)
    {
      if (bVal > 9)
        return (char)(bVal - 10 + 'A');
      else
        return (char)(bVal + '0');
    }

    static string MakeHexString(byte[]Arr)
    {
      string strLine;
      strLine = "";
      for (int i = Arr.Length-1; (i >= 0) ;--i)
      {
        byte lChar = (byte)(Arr[i] & 0x0F);
        byte hChar = (byte)((Arr[i]>>4)&0x0F);

        strLine += cNibble(hChar);
        strLine += cNibble(lChar);
      }
      return strLine;
    }

    static void CopyArrayTo(SByte[] Src, int SrcOffset, SByte[] Dest, int DestOffset, int Len)
    {
      while (Len > 0)
      {
        Dest[DestOffset++] = Src[SrcOffset++];
        Len--;
      }
    }

    static public int bGood = 0;
    static public string LastVal = "";
    static private int onCallback(string Arr,int Len)
    {
      if (Len == 0)
      {
        bGood = -1;
        return 0;
      }

      Console.Out.Write("Received: ");
      Console.Out.Write(Arr);
      Console.Out.WriteLine();

      if (LastVal.Length == 0)
      {
        
        LastVal = Arr;
        bGood = 1;
      }
      else
      {
        if (Arr == LastVal)
          bGood = 2;
        else
          bGood = 3;
      }
      return 0;
    }
    
    static void Main(string[] args)
    {
      int MaxLen = 255;
      int ListLen = 0;
      int DevListLen;
      int Handle = 0;
      int DeviceCount;

      SByte[] NamenListe = new SByte[1000];
      SByte[] DevList = new SByte[MaxLen];

      GIS_URW_API.AutoReadCallback AutoReadProc = new GIS_URW_API.AutoReadCallback(onCallback);

      DevListLen = GIS_URW_API.TSURW_GetCOMDeviceNames(DevList, MaxLen)-1;
      CopyArrayTo(DevList, 0, NamenListe, ListLen, DevListLen);
      ListLen += DevListLen;
      DevListLen = GIS_URW_API.TSURW_GetUSBDeviceNames(DevList, MaxLen)-1;
      CopyArrayTo(DevList, 0, NamenListe, ListLen, DevListLen);
      ListLen += DevListLen;
      DevListLen = GIS_URW_API.TSURW_GetLanDeviceNames(DevList, MaxLen)-1;
      CopyArrayTo(DevList, 0, NamenListe, ListLen, DevListLen);
      ListLen += DevListLen;
      ListLen++;

      if (ListLen > 1)
      {
        string DeviceName;
        int DeviceNr;

        Console.Out.Write("Device found ");
        DeviceCount = 0;
        do
        {
          DeviceName = MakeStringFromArray(NamenListe, DeviceCount);
          if (DeviceName.Length > 0)
          {
            Console.Out.Write("Device {0,0:D} ", DeviceCount + 1);
            Console.Out.Write(DeviceName);
            Console.Out.WriteLine();
          }
          DeviceCount++;
        }
        while (DeviceName.Length > 0);

        Console.Out.Write("Select Device:");
        DeviceNr = Convert.ToInt32(Console.In.ReadLine());

        DeviceName = MakeStringFromArray(NamenListe, DeviceNr - 1);

        Console.Out.Write("Open Device: ");
        Console.Out.Write(DeviceName);
        Console.Out.WriteLine();

        Handle = GIS_URW_API.TSURW_Open(DeviceName, 19200, 0, 500);

        if (Handle > 0)
        {
          // activate Reader Mode, because the device might anyway be set to Programmer mode
          GIS_URW_API.TSURW_SetReaderMode(Handle, 1);

          GIS_URW_API.TSURW_StartAutoRead(Handle, '\r', AutoReadProc);

          while (!Console.KeyAvailable)
          {
            System.Threading.Thread.Sleep(100);
            switch (bGood)
            {
              case 0:
                break;
              case 1:
                GIS_URW_API.TSURW_SetLED(Handle, 0, 1, 0);
                bGood = 0;
                break;
              case 2:
                GIS_URW_API.TSURW_SetLED(Handle, 1, 0, 0);
                GIS_URW_API.TSURW_Beep(Handle);
                bGood = 0;
                break;
              case 3:
                GIS_URW_API.TSURW_SetLED(Handle, 0, 0, 1);
                bGood = 0;
                break;

            }
            if (bGood == -1)
            {
              // Reader was removed
              // Leave this
              Console.Out.WriteLine("Fatal Error: Device was Removed.");
              Console.Out.WriteLine("Press Key to continue");
              break;
            }
          }
          Console.ReadKey();
          GIS_URW_API.TSURW_SetLED(Handle, 2, 2, 2);
          GIS_URW_API.TSURW_StopAutoRead(Handle);
        }
        GIS_URW_API.TSURW_Close(Handle);
      }
      Console.Out.Write("Wait for Key to exit");
      while (!Console.KeyAvailable) ;
    }
  }
}
