// ReaderModeCpp.cpp : Definiert den Einstiegspunkt fr die Konsolenanwendung.
//

#include "stdafx.h"
#include "ReaderModeCpp.h"
#include "..\..\TS_URW_Import.h"
#include "conio.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#ifdef _WIN64
#pragma comment(lib,"..\\..\\TS_URW_SDK64.lib")
#else
#pragma comment(lib,"..\\..\\TS_URW_SDK.lib")
#endif

// Das einzige Anwendungsobjekt

CWinApp theApp;

char LastVal[100];
int LastValLen = 0;
int bGood = 0;

using namespace std;
extern "C" int __stdcall AutoReadProc(char * pData, int Len)
{
  if (Len == 0)
  {
    // Recognizing Reader was removed
    bGood = -1;
    return 0;
  }

  for (int i = 0; pData[i] && (i < Len); i++)
    _putch(pData[i]);
  _putch('\r');
  _putch('\n');

  if (LastValLen == 0)
  {
    memcpy(LastVal, pData, Len);
    LastValLen = Len;
    bGood = 1;
  }
  else
  {
    if ((LastValLen == Len) && (memcmp(pData,LastVal,Len) == 0))
      bGood = 2;
    else
      bGood = 3;
  }
  return 0;
}

static CString MakeStringFromArray(CByteArray& Arr, int StringNummer)
{
  CString strLine;
  strLine = "";

  int i = 0;
  for (int aktStringNummer = 0; aktStringNummer <= StringNummer; aktStringNummer++)
  {
    strLine = "";
    for (; (i < Arr.GetSize()); i++)
    {
      if (Arr[i] == 0)
      {
        break;
      }
      strLine += (char)Arr[i];
    }
    i++;
    if (strLine.GetLength() == 0)
      break;
  }
  return strLine;
}

static void MakeArrayFromString(CString Name, CByteArray &arr)
{
  arr.SetSize(Name.GetLength() + 1);
  int i = 0;
  for (i = 0; i < Name.GetLength(); i++)
    arr[i] = (BYTE)Name[i];
  arr[i] = 0;
}

int main()
{
    int nRetCode = 0;

    HMODULE hModule = ::GetModuleHandle(nullptr);

    if (hModule != nullptr)
    {
      if (!AfxWinInit(hModule, nullptr, ::GetCommandLine(), 0))
      {
        _tprintf(_T("Error at MFC-Initializing\n"));
        nRetCode = 1;
      }
      else
      {
        printf("Searching for Device...");

        int MaxLen = 1000;
        int ListLen = 0;
        int nPortHandle = -1;
        int DeviceCount;

        CByteArray NamenListe;
        NamenListe.SetSize(MaxLen);

        ListLen += TSURW_GetCOMDeviceNames((char*)NamenListe.GetData() + ListLen, MaxLen - ListLen) - 1;
        ListLen += TSURW_GetUSBDeviceNames((char*)NamenListe.GetData() + ListLen, MaxLen - ListLen) - 1;
        ListLen += TSURW_GetLanDeviceNames((char*)NamenListe.GetData() + ListLen, MaxLen - ListLen) - 1;
        ListLen++;
        if (ListLen > 1)
        {
          CString DeviceName;
          int DeviceNr;

          _tprintf(_T("Device found "));
          DeviceCount = 0;
          do
          {
            DeviceName = MakeStringFromArray(NamenListe, DeviceCount);
            if (DeviceName.GetLength() > 0)
            {
              _tprintf(_T("Device %d "), DeviceCount + 1);
              _tprintf(DeviceName);
              _tprintf(_T("\n"));
            }
            DeviceCount++;
          }
          while (DeviceName.GetLength() > 0);

          _tprintf(_T("Select Device:"));
          _tscanf_s(_T("%d"), &DeviceNr);

          DeviceName = MakeStringFromArray(NamenListe, DeviceNr - 1);
          CByteArray DeviceNameArr;
          MakeArrayFromString(DeviceName, DeviceNameArr);

          _tprintf(_T("Open Device: "));
          _tprintf(DeviceName);
          _tprintf(_T("\n"));

          nPortHandle = TSURW_Open((char*)DeviceNameArr.GetData(), 19200, 0, 1000);

          if (nPortHandle > 0)
          {
            // If Reader is possible, then
            // activate Reader Mode, because the device might anyway be set to Programmer mode
            TSURW_SetReaderMode(nPortHandle, 1);

            TSURW_StartAutoRead(nPortHandle, '\r', AutoReadProc);

            while (!_kbhit())
            {
              Sleep(100);
              switch (bGood)
              {
                case 0:
                  break;
                case 1:
                  TSURW_SetLED(nPortHandle, 0, 1, 0);
                  bGood = 0;
                  break;
                case 2:
                  TSURW_SetLED(nPortHandle, 1, 0, 0);
                  TSURW_Beep(nPortHandle);
                  bGood = 0;
                  break;
                case 3:
                  TSURW_SetLED(nPortHandle, 0, 0, 1);
                  bGood = 0;
                  break;
              }
              if (bGood == -1)
              {
                // Reader was removed
                // Leave this
                _tprintf(_T("Fatal Error: Device was Removed.\nPress Key to continue\n"));
                break;
              }
            }

            TSURW_SetLED(nPortHandle, 2, 2, 2);
            TSURW_StopAutoRead(nPortHandle);
            _getch();
            TSURW_Close(nPortHandle);
          }
          else
          {
            _tprintf(_T("Error %d at TSHRW_OpenPort"), -nPortHandle);
            _tprintf(_T("\n"));
          }
        }
        else
        {
          _tprintf(_T("No Device found"));
          _tprintf(_T("\n"));
        }
      }
    }
    else
    {
        // TODO: Den Fehlercode an Ihre Anforderungen anpassen.
        _tprintf(_T("Fatal Error: at GetModuleHandle.\n"));
        nRetCode = 1;
    }

    _tprintf(_T("Wait for Key to exit"));
    while (!_kbhit());

    return nRetCode;
}
