﻿Public Class TS_URWTest

  Dim myHandle As Integer

  Private Function OpenIfNeeded() As Boolean
    If (myhandle > 0) Then
      ' Device already opened
      Return True
    End If
    If (DeviceList.SelectedIndex < 0) Then
      Return False
    End If
    Dim DeviceName As String = DeviceList.SelectedItem.ToString
    If (DeviceName.Length > 0) Then
      Dim DeviceNameArr() As SByte = New SByte(((DeviceName.Length + 1)) - 1) {}
      MakeArrayFromString(DeviceNameArr, DeviceName)
      myHandle = TSURW_Open(DeviceNameArr(0), 19200, 0, 500)
      If (myHandle > 0) Then
        DeviceList.Enabled = False
        Return True
      End If
    End If
    Return False
  End Function

  Private Shared Function MakeStringFromArray(ByVal Arr() As Byte, ByRef StartIdx As Integer) As String
    Dim strLine As String
    strLine = ""
    Dim i As Integer
    i = StartIdx
    Do While ((i < Arr.Length) AndAlso (Arr(i) <> 0))
      strLine = (strLine + Microsoft.VisualBasic.ChrW(Arr(i)))
      i = (i + 1)
    Loop    
    StartIdx = i+1
    Return strLine
  End Function

  Private Shared Function MakeStringFromData(ByVal Arr() As Byte, ByVal StartIdx As Integer, ByVal EndIdx As Integer) As String
    Dim strLine As String
    strLine = ""
    Dim i As Integer
    i = StartIdx
    Do While (i <= EndIdx)
      strLine = (strLine + String.Format("{0:X2}", Arr(i)))
      strLine = (strLine + " ")
      i = (i + 1)
    Loop
    StartIdx = i
    Return strLine
  End Function

  Private Shared Function MakeArrayFromString(ByRef Arr() As System.SByte, ByVal str As String) As Integer
    Dim i As Integer
    i = 0
    Do While (i < str.Length)
      Arr(i) = Microsoft.VisualBasic.AscW(str(i))
      i = (i + 1)
    Loop
    Arr(i) = 0
    Return i
  End Function

  Private Shared Function MakeHex(ByVal high As Char, ByVal low As Char) As Byte
    Dim str As String = ""
    str = (str + high)
    str = (str + low)
    Return Convert.ToByte(str, 16)
  End Function

  Private Shared Function MakeDataFromString(ByRef Arr() As Byte, ByVal str As String) As Integer
    Dim i As Integer
    Dim s2 As Integer
    Dim s1 As Integer
    Dim bytevalue As Byte

    str.TrimStart(Microsoft.VisualBasic.ChrW(32))
    str.TrimEnd(Microsoft.VisualBasic.ChrW(32))
    s1 = 0
    s2 = 0
    i = 0

    While ((i <= Arr.Length) AndAlso (s2 < str.Length))
      s1 = s2

      While ((s2 < (s1 + 2)) AndAlso (s2 < str.Length))
        If (str(s2) = Microsoft.VisualBasic.ChrW(32)) Then
          Exit While
        End If
        s2 = (s2 + 1)

      End While
      If (s2 = (s1 + 2)) Then
        bytevalue = MakeHex(str(s1), str((s1 + 1)))
      Else
        bytevalue = MakeHex(str(s1), Microsoft.VisualBasic.ChrW(48))
      End If
      Arr(i) = bytevalue
      i = (i + 1)

      While ((s2 < str.Length) AndAlso (str(s2) = Microsoft.VisualBasic.ChrW(32)))
        s2 = (s2 + 1)
      End While

    End While
    Return i
  End Function

  Private Sub CloseIfOpen()
    If (myHandle > 0) Then
      TSURW_Close(myHandle)
    End If
    myHandle = 0
    DeviceList.Enabled = True
  End Sub

  Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
    myHandle = 0
    StartAddress.Text = "0"
    Length.Text = "4"
    MemoryBank.SelectedIndex = 3
  End Sub

  Private Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs) Handles MyBase.FormClosing
    CloseIfOpen()
  End Sub

  Private Sub OnScan(sender As Object, e As EventArgs) Handles ScanDevices.Click
    Dim MaxLen As Integer = 255
    Dim ListLen As Integer = 0
    Dim NamenListe(MaxLen) As Byte
    CloseIfOpen()
    DeviceList.Items.Clear()
    ListLen = TSURW_GetUSBDeviceNames(NamenListe(0), MaxLen)
    If (ListLen > 1) Then
      Dim StartIdx As Integer = 0
      Dim Name As String

      While (True)
        Name = MakeStringFromArray(NamenListe, StartIdx)
        If (Name.Length > 0) Then
          DeviceList.Items.Add(Name)
        Else
          Exit While
        End If
      End While
    End If
    ListLen = TSURW_GetCOMDeviceNames(NamenListe(0), MaxLen)
    If (ListLen > 1) Then
      Dim StartIdx As Integer = 0
      Dim Name As String

      While (True)
        Name = MakeStringFromArray(NamenListe, StartIdx)
        If (Name.Length > 0) Then
          DeviceList.Items.Add(Name)
        Else
          Exit While
        End If
      End While

    End If
    If (DeviceList.Items.Count > 0) Then
      DeviceList.SetSelected(0, True)
    End If

  End Sub


  Private Sub ReadInventory_Click(sender As Object, e As EventArgs) Handles ReadInventory.Click
    InventoryData.Text = ""
    If OpenIfNeeded() Then
      Dim BufLen As Integer = 100
      Dim UsedLen As Integer
      Dim Buffer() As Byte = New Byte((BufLen) - 1) {}
      UsedLen = TSURW_Inventory(myHandle, 0, Buffer(0), BufLen)
      If (UsedLen > 0) Then
        InventoryData.Text = MakeStringFromData(Buffer, 3, (UsedLen - 1))
      End If
    End If
  End Sub

  Private Sub ReadMemory_Click(sender As Object, e As EventArgs) Handles ReadMemory.Click
    BlockData.Text = ""
    If OpenIfNeeded() Then
      Dim UsedLen As Integer
      Dim MemType As Integer
      Dim StartIdx As Integer
      Dim Len As Integer
      MemType = MemoryBank.SelectedIndex
      StartIdx = Convert.ToInt32(StartAddress.Text)
      Len = Convert.ToInt32(Length.Text)
      Dim Buffer() As Byte = New Byte((Len) - 1) {}
      Dim UIDLen As Integer
      Dim InventoryBuffer() As Byte = New Byte(16) {}
      UIDLen = MakeDataFromString(InventoryBuffer, InventoryData.Text)
      If (TSURW_Select(myHandle, InventoryBuffer(0), UIDLen) >= 0) Then
        UsedLen = TSURW_ReadData(myHandle, MemType, (StartIdx / 2), Buffer(0), Len)
        If (UsedLen > 0) Then
          BlockData.Text = MakeStringFromData(Buffer, 0, (UsedLen - 1))
        End If
      End If
    End If
  End Sub

  Private Sub WriteMemory_Click(sender As Object, e As EventArgs) Handles WriteMemory.Click
    If OpenIfNeeded() Then
      Dim BufLen As Integer = 100
      Dim UsedLen As Integer
      Dim MemType As Integer
      Dim StartIdx As Integer
      Dim Len As Integer

      MemType = MemoryBank.SelectedIndex
      StartIdx = Convert.ToInt32(StartAddress.Text)
      Len = Convert.ToInt32(Length.Text)

      Dim UIDLen As Integer
      Dim InventoryBuffer() As Byte = New Byte(16) {}
      UIDLen = MakeDataFromString(InventoryBuffer, InventoryData.Text)
      If (TSURW_Select(myHandle, InventoryBuffer(0), UIDLen) >= 0) Then
        Dim Buffer() As Byte = New Byte((Len) - 1) {}
        MakeDataFromString(Buffer, BlockData.Text)
        UsedLen = TSURW_WriteData(myHandle, MemType, (StartIdx / 2), Buffer(0), Len)
        If (UsedLen >= 0) Then
          MessageBox.Show("Successfully written")
        End If
      End If
    End If
  End Sub

End Class
