
// TS_URW_DemoVCDlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "TS_URW_DemoVC.h"
#include "TS_URW_DemoVCDlg.h"
#include "afxdialogex.h"

#include "..\..\TS_URW_Import.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg-Dialogfeld fr Anwendungsbefehl "Info"

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Dialogfelddaten
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung

// Implementierung
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CTS_URW_DemoVCDlg-Dialogfeld



CTS_URW_DemoVCDlg::CTS_URW_DemoVCDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CTS_URW_DemoVCDlg::IDD, pParent)
  , m_StartByte(0)
  , m_Length(4)
  , m_Data(_T(""))
  , m_Inventory(_T(""))
{
  m_myHandle = 0;
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

bool CTS_URW_DemoVCDlg::OpenIfNeeded()
{
  if (m_myHandle > 0)
  {
    // Device already opened
    return true;
  }

  if (m_DeviceList.GetCurSel() < 0)
    return false;

  CString DeviceName;
  m_DeviceList.GetText(m_DeviceList.GetCurSel(),DeviceName);
  if (DeviceName.GetLength() > 0)
  {
    char DeviceNameArr[100];
    MakeArrayFromString(DeviceNameArr, DeviceName);

    m_myHandle = TSURW_Open(DeviceNameArr, 19200, 0, 500);
    if (m_myHandle > 0)
    {
      m_DeviceList.EnableWindow(FALSE);
      return true;
    }
  }
  return false;
}

void CTS_URW_DemoVCDlg::CloseIfOpen()
{
  if (m_myHandle > 0)
    TSURW_Close(m_myHandle);
  m_myHandle = 0;
  m_DeviceList.EnableWindow(TRUE);
}

CString CTS_URW_DemoVCDlg::MakeStringFromArray(char Arr[], int ArrLength, int &StartIdx)
{
  CString strLine;
  strLine = "";
  int i;
  for (i = StartIdx; (i < ArrLength) && (Arr[i] != 0); i++)
  {
    strLine += (char)Arr[i];
  }
  i++;
  StartIdx = i;
  return strLine;
}

CString CTS_URW_DemoVCDlg::MakeStringFromData(byte Arr[], int StartIdx, int EndIdx)
{
  CString strLine;
  CString item;
  strLine = "";
  int i;
  for (i = StartIdx; (i <= EndIdx); i++)
  {
    item.Format(_T("%02X"), Arr[i]);
    strLine += item;
    strLine += " ";
  }
  StartIdx = i;
  return strLine;
}

int CTS_URW_DemoVCDlg::MakeArrayFromString(char Arr[], CString str)
{
  int i;
  for (i = 0; i < str.GetLength(); i++)
    Arr[i] = (char)str[i];
  Arr[i] = 0;
  return i;
}

static byte ASCII2Hex(TCHAR ch)
{
  if ((ch >= '0') && (ch <= '9'))
    return ch - '0';
  else if ((ch >= 'A') && (ch <= 'F'))
    return ch - 'A' + 10;
  else if ((ch >= 'a') && (ch <= 'f'))
    return ch - 'a' + 10;
  return 0;
}

byte CTS_URW_DemoVCDlg::MakeHex(TCHAR high, TCHAR low)
{
  return ASCII2Hex(high)<<4 | ASCII2Hex(low);
}

int CTS_URW_DemoVCDlg::MakeDataFromString(byte Arr[], int ArrLength, CString str)
{
  int i;
  int s1, s2;

  str.TrimLeft(' ');
  str.TrimRight(' ');
  s1 = 0; s2 = 0; i = 0;

  while ((i <= ArrLength) && (s2<str.GetLength()))
  {
    s1 = s2;
    while ((s2 < s1 + 2) && (s2<str.GetLength()))
    {
      if (str[s2] == ' ')
        break;
      s2++;
    }
    if (s2 == s1 + 2)
      Arr[i++] = MakeHex(str[s1], str[s1 + 1]);
    else
      Arr[i++] = MakeHex(str[s1], '0');
    while ((s2<str.GetLength()) && (str[s2] == ' '))
      s2++;
  }
  return i;
}

void CTS_URW_DemoVCDlg::DoDataExchange(CDataExchange* pDX)
{
  CDialogEx::DoDataExchange(pDX);
  DDX_Text(pDX, IDC_START_BYTE, m_StartByte);
  DDX_Text(pDX, IDC_LENGTH, m_Length);
  DDX_Text(pDX, IDC_DATA, m_Data);
  DDX_Text(pDX, IDC_INVENTORY, m_Inventory);
  DDX_Control(pDX, IDC_DEVICE_LIST, m_DeviceList);
  DDX_Control(pDX, IDC_MEMORY_BANK, m_MemoryBank);
  DDX_Control(pDX, IDC_STATUS, m_StatusCtrl);
}

BEGIN_MESSAGE_MAP(CTS_URW_DemoVCDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
  ON_BN_CLICKED(IDC_READ_DATA, &CTS_URW_DemoVCDlg::OnClickedReadData)
  ON_BN_CLICKED(IDC_READ_INVENTORY, &CTS_URW_DemoVCDlg::OnClickedReadInventory)
  ON_BN_CLICKED(IDC_WRITE_DATA, &CTS_URW_DemoVCDlg::OnClickedWriteData)
  ON_BN_CLICKED(IDC_SCAN, &CTS_URW_DemoVCDlg::OnClickedScan)
  ON_BN_CLICKED(IDC_AUTOREAD, &CTS_URW_DemoVCDlg::OnClickedAutoread)
END_MESSAGE_MAP()


// CTS_URW_DemoVCDlg-Meldungshandler

BOOL CTS_URW_DemoVCDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Hinzufgen des Menbefehls "Info..." zum Systemmen.

	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Symbol fr dieses Dialogfeld festlegen.  Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden

  m_MemoryBank.SetCurSel(3);

	return TRUE;  // TRUE zurckgeben, wenn der Fokus nicht auf ein Steuerelement gesetzt wird
}

void CTS_URW_DemoVCDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// Wenn Sie dem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie
//  den nachstehenden Code, um das Symbol zu zeichnen.  Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch ausgefhrt.

void CTS_URW_DemoVCDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext zum Zeichnen

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Symbol in Clientrechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// Die System ruft diese Funktion auf, um den Cursor abzufragen, der angezeigt wird, whrend der Benutzer
//  das minimierte Fenster mit der Maus zieht.
HCURSOR CTS_URW_DemoVCDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



BOOL CTS_URW_DemoVCDlg::DestroyWindow()
{
  CloseIfOpen();

  return CDialogEx::DestroyWindow();
}


void CTS_URW_DemoVCDlg::OnClickedScan()
{
    int MaxLen = 255;
    int ListLen = 0;
    char NamenListe[255];

    CloseIfOpen();

    m_DeviceList.ResetContent();
    ListLen = TSURW_GetUSBDeviceNames(NamenListe, MaxLen);

    if (ListLen > 1)
    {
      int StartIdx = 0;
      CString Name;
      do
      {
        Name = MakeStringFromArray(NamenListe, ListLen, StartIdx);
        if (Name.GetLength() > 0)
          m_DeviceList.AddString(Name);
      }
      while (Name.GetLength() > 0);
    }

    ListLen = TSURW_GetCOMDeviceNames(NamenListe, MaxLen);
    if (ListLen > 1)
    {
      int StartIdx = 0;
      CString Name;
      do
      {
        Name = MakeStringFromArray(NamenListe, ListLen, StartIdx);
        if (Name.GetLength() > 0)
          m_DeviceList.AddString(Name);
      }
      while (Name.GetLength() > 0);
    }
    if (m_DeviceList.GetCount() > 0)
      m_DeviceList.SetCurSel(0);
}


void CTS_URW_DemoVCDlg::OnClickedReadInventory()
{
  UpdateData(TRUE);
  m_Inventory = "";
  UpdateData(FALSE);

  if (OpenIfNeeded())
  {
    int BufLen = 100;
    int UsedLen;
    byte Buffer[100];

    UsedLen = TSURW_Inventory(m_myHandle, 0, Buffer, BufLen);
    if (UsedLen > 0)
    {
      m_Inventory = MakeStringFromData(Buffer, 3, UsedLen-1);
    }
  }
  UpdateData(FALSE);
}


void CTS_URW_DemoVCDlg::OnClickedReadData()
{
  UpdateData(TRUE);
  m_Data = "";
  UpdateData(FALSE);
  if (OpenIfNeeded())
  { 
    int UsedLen;
    int MemType;
    int StartIdx;
    int Len;
    int UIDLen;

    MemType = m_MemoryBank.GetCurSel();
    StartIdx = m_StartByte;
    Len = m_Length;
    byte Buffer[100];

    byte InventoryBuffer[16];

    UIDLen = MakeDataFromString(InventoryBuffer, 16, m_Inventory);
    if (TSURW_Select(m_myHandle, InventoryBuffer, UIDLen) < 0)
      return;

    UsedLen = TSURW_ReadData(m_myHandle, MemType,StartIdx/2,Buffer, Len);
    if (UsedLen > 0)
    {
      m_Data = MakeStringFromData(Buffer, 0, UsedLen-1);
    }
  }
  UpdateData(FALSE);
}


void CTS_URW_DemoVCDlg::OnClickedWriteData()
{
  UpdateData(TRUE);

  if (OpenIfNeeded())
  { 
    int BufLen = 100;
    int UsedLen;
    int MemType;
    int StartIdx;
    int Len;
    int UIDLen;

    MemType = m_MemoryBank.GetCurSel();
    StartIdx = m_StartByte;
    Len = m_Length;
    byte Buffer[100];

    byte InventoryBuffer[16];

    UIDLen = MakeDataFromString(InventoryBuffer, 16, m_Inventory);
    if (TSURW_Select(m_myHandle, InventoryBuffer, UIDLen) < 0)
      return;

    MakeDataFromString(Buffer, 100, m_Data);

    UsedLen = TSURW_WriteData(m_myHandle, MemType,StartIdx/2,Buffer, Len);
    if (UsedLen >= 0)
      AfxMessageBox(_T("Successfully written"));
  }
  UpdateData(FALSE);
}

#define WAIT_BEFORE_INVENTORY   0
#define WAIT_AFTER_INVENTORY    0
#define WAIT_AFTER_SELECT       0


void CTS_URW_DemoVCDlg::OnClickedAutoread()
{
  if (!IsDlgButtonChecked(IDC_AUTOREAD))
    return;

  CString strStatus;
  int nReadOK = 0;
  int nInventoryError = 0;
  int nSelectError = 0;
  int nReadError = 0;

  UpdateData(TRUE);
  m_Data = "";
  UpdateData(FALSE);

  if (OpenIfNeeded())
  {
    TSURW_KeepAppActive(m_myHandle,1);
    while (IsDlgButtonChecked(IDC_AUTOREAD))
    {
      int BufLen = 100;
      int UsedLen;
      byte Buffer[100];
      //Sleep(WAIT_BEFORE_INVENTORY);
      UsedLen = TSURW_Inventory(m_myHandle, 0, Buffer, BufLen);
      if (UsedLen > 1)
      {
        m_Inventory = MakeStringFromData(Buffer, 3, UsedLen - 1);
        int UsedLen;
        int MemType;
        int StartIdx;
        int Len;
        int UIDLen;

        MemType = m_MemoryBank.GetCurSel();
        StartIdx = m_StartByte;
        Len = m_Length;
        byte Buffer[100];

        byte InventoryBuffer[16];

        //Sleep(WAIT_AFTER_INVENTORY);
        UIDLen = MakeDataFromString(InventoryBuffer, 16, m_Inventory);
        if (TSURW_Select(m_myHandle, InventoryBuffer, UIDLen) >= 0)
        {
          //Sleep(WAIT_AFTER_SELECT);
          UsedLen = TSURW_ReadData(m_myHandle, MemType, StartIdx / 2, Buffer, Len);
          if (UsedLen > 0)
          {
            m_Data = MakeStringFromData(Buffer, 0, UsedLen - 1);
            UpdateData(FALSE);
            nReadOK++;
          }
          else
          {
            nReadError++;
          }
        }
        else
        {
          nSelectError++;
        }
      }
      else
      {
        nInventoryError++;
      }
      int nVersuche = nInventoryError + nSelectError + nReadError + nReadOK;
      int nInvProz  = nInventoryError*100/nVersuche;
      int nSelProz  = nSelectError*100/nVersuche;
      int nReadProz = nReadError*100/nVersuche;
      int nOKProz   = nReadOK*100/nVersuche;
      strStatus.Format(_T("Inventory error: %d (%d %%), Select error: %d (%d %%), Read error: %d (%d %%), Read ok: %d (%d %%)"), nInventoryError, nInvProz, nSelectError, nSelProz, nReadError, nReadProz, nReadOK, nOKProz);
      m_StatusCtrl.SetWindowText(strStatus);
    }
    TSURW_KeepAppActive(m_myHandle, 0);
  }
}
