' Use this file with VB6

Attribute VB_Name = "TSURW"
Option Explicit

'Fehlerliste  Dll Funktionsaufrufe
Global Const  TSURW_NO_ERROR = 0
Global Const  TSURW_PORT_OEFFNEN = 1
Global Const  TSURW_TIMEOUT_UNGUELTIG = 2
Global Const  TSURW_PORTHANDLE_UNGUELTIG = 3
Global Const  TSURW_TIMEOUT = 4
Global Const  TSURW_BUFFER_ZU_KLEIN = 5
Global Const  TSURW_BUFFERGROESSE_FALSCH = 6
Global Const  TSURW_KEINE_SENDEDATEN = 8
Global Const  TSURW_CHECKSUMMENFEHLER = 10
Global Const  TSURW_KEINE_KOMMUNIKATION = 11
Global Const  TSURW_CHECKBUFFER_LEER = 12
Global Const  TSURW_MODE_UNGUELTIG = 13
Global Const  TSURW_BEFEHL_NICHT_ERLAUBT = 14
Global Const  TSURW_BLOCKNR_UNGUELTIG = 15
Global Const  TSURW_NO_VALUE = 19
Global Const  TSURW_DATENANZAHL = 20
Global Const  TSURW_NO_TAG = 21
Global Const  TSURW_KOLLISION = 23
Global Const  TSURW_UNBEKANNTES_KOMMANDO = 24

'Leserfehler
Global Const TSURW_NACK = 21
Global Const TSURW_SYNC = 22
Global Const TSURW_CANCEL = 24

'Rckgabewerte
Global Const TSURW_RETVAL_ERROR = -1
Global Const TSURW_RETVAL_OK = 0

'EPC Mem Banks 
'Definition for EPC tag memory bank: reserved 
Global Const MEM_RES = 0
' Definition for EPC tag memory bank: EPC memory 
Global Const MEM_EPC = 1
' Definition for EPC tag memory bank: TID 
Global Const MEM_TID = 2
' Definition for EPC tag memory bank: user 
Global Const MEM_USER = 3

' Definition der Inventorytypen
Global Const INVENTORY_NEW = 0
Global Const INVENTORY_START = 1
Global Const INVENTORY_NEXT = 2
Global Const INVENTORY_TID  = 3

'// Get Library Version
Public Declare Function TSURW_LibVersion Lib "TS_URW_SDK.DLL" () As Long

Public Declare Function TSURW_IsVirtualComInstalled Lib "TS_URW_SDK.DLL" () As Long

'// Get Names of all USB Devices connected, only valid devices are listed
Public Declare Function TSURW_GetUSBDeviceNames Lib "TS_URW_SDK.DLL" (Buffer As Any, ByVal nBufferSize As Long) As Long

'// Get Names of all USB Devices connected, all devices from GiS are listed
Public Declare Function TSURW_GetUSBDeviceNamesEx Lib "TS_URW_SDK.DLL" (Buffer As Any, ByVal nBufferSize As Long) As Long

'// Get Names of all COM Ports available, not tested if there is a device at the port connected.
Public Declare Function TSURW_GetCOMDeviceNames Lib "TS_URW_SDK.DLL" (Buffer As Any, ByVal nBufferSize As Long) As Long

'// Get Names of all valid LAN devices found in same subnet
Public Declare Function TSURW_GetLanDeviceNames Lib "TS_URW_SDK.DLL" (Buffer As Any, ByVal nBufferSize As Long) As Long

'// Get Names of all LAN devices found even in other subnets
Public Declare Function TSURW_GetLanDeviceNamesEx Lib "TS_URW_SDK.DLL" (Buffer As Any, ByVal nBufferSize As Long) As Long

'// Change IP Address of LAN device
Public Declare Function TSURW_ChangeLanIPAddress Lib "TS_URW_SDK.DLL" (OldAddress As Any, NewAddress As Any, IPMask As Any) As Long

'// Change IP Address and Gateway of LAN device
Public Declare Function TSURW_ChangeLanIPAddressEx Lib "TS_URW_SDK.DLL" (OldAddress As Any, NewAddress As Any, IPMask As Any, Gateway As Any) As Long

'// Get IP Address and Gateway of LAN device
Public Declare Function TSURW_GetLanIPAddressEx Lib "TS_URW_SDK.DLL" (OldAddress As Any, NewAddress As Any, IPMask As Any, Gateway As Any) As Long

'// Check if specific LAN device is available
Public Declare Function TSURW_IsLanDeviceAvailable Lib "TS_URW_SDK.DLL" (Address As Any) As Long

'// Open LAN Device for configuration
Public Declare Function TSURW_LanConfigOpen Lib "TS_URW_SDK.DLL" (strName As Any) As Long

'// Set Configuration Record of LAN device, use with care!
Public Declare Function TSURW_LanConfigGet Lib "TS_URW_SDK.DLL" (ByVal handle As Long, ByVal RecordNr As Long, pData As Any, ByVal DatLen As Long) As Long

'// Get Configuration Record of LAN device
Public Declare Function TSURW_LanConfigSet Lib "TS_URW_SDK.DLL" (ByVal handle As Long, ByVal RecordNr As Long, pData As Any, ByVal DatLen As Long) As Long

'// Close LAN device configuration.
Public Declare Function TSURW_LanConfigClose Lib "TS_URW_SDK.DLL" (ByVal handle As Long, ByVal Reset As Long) As Long

'// Read Configuration of USB HID device
Public Declare Function TSURW_HIDConfigRead Lib "TS_URW_SDK.DLL" (ByVal handle As Long, pSendBuf As Any, ByVal SendBufLen As Long, pRecvBuf As Any, ByVal RecvBufLen As Long) As Long
'// Write Configuration to USB HID device
Public Declare Function TSURW_HIDConfigWrite Lib "TS_URW_SDK.DLL" (ByVal handle As Long, pSendBuf As Any, ByVal SendBufLen As Long) As Long

Public Declare Function TSURW_Open Lib "TS_URW_SDK.DLL" (Name As Any, ByVal Baudrate As Long, ByVal ParityMode As Long, ByVal Timeout As Long) As Long

Public Declare Function TSURW_Close Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Long) As Long

Public Declare Function TSURW_KeepAppActive Lib "TS_URW_SDK.DLL" (ByVal handle As Long, ByVal bActive As Long) As Long

Public Declare Function TSURW_SetReaderAdresse Lib "TS_URW_SDK.DLL" (ByVal handle As Long, ByVal Adresse As Long) As Long

Public Declare Function TSURW_GetDeviceVersion Lib "TS_URW_SDK.DLL" (ByVal handle As Long, pDevVer As Any, ByVal VerLen As Long, pDevName As Any, ByVal NameLen As Long) As Long

Public Declare Function TSURW_IsUSB Lib "TS_URW_SDK.DLL" (ByVal handle As Long) As Long

Public Declare Function TSURW_SetBaudrate Lib "TS_URW_SDK.DLL" (ByVal handle As Long, ByVal Baudrate As Long, ByVal ParityMode As Long) As Long

Public Declare Function TSURW_SetReaderMode Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Long, ByVal Mode As Long) As Long

Public Declare Function TSURW_SetRF Lib "TS_URW_SDK.DLL" (ByVal handle As Long, ByVal OnOff As Long) As Long

Public Declare Function TSURW_GetLastError Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Long) As Long

Public Declare Function TSURW_SetIO Lib "TS_URW_SDK.DLL" (ByVal handle As Long, ByVal Maske As Long, ByVal Daten As Long) As Long
Public Declare Function TSURW_ReadIO Lib "TS_URW_SDK.DLL" (ByVal handle As Long, pDaten As Long) As Long

Public Declare Function TSURW_SetLED Lib "TS_URW_SDK.DLL" (ByVal handle As Long, ByVal red As Long, ByVal green As Long, ByVal yellow As Long) As Long
Public Declare Function TSURW_Beep Lib "TS_URW_SDK.DLL" (ByVal handle As Long) As Long

Public Declare Function TSURW_ReadSerialNumber Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Long, pSerial As Any, ByVal BufLen As Long) As Long

Public Declare Function TSURW_SetConfig Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Long, pConfig As Any, ByVal ConfigLen As Long) As Long
Public Declare Function TSURW_GetConfig Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Long, pConfig As Any, ByVal ConfigLen As Long) As Long

Public Declare Function TSURW_SetDefault Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Long) As Long

Public Declare Function TSURW_SetCommunicationMode Lib "TS_URW_SDK.DLL" (ByVal handle As Long, ByVal Mode As Long) As Long

Public Declare Function TSURW_RawRead Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Long, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSURW_RawWrite Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Long, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSURW_Transfer Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Long, ByVal Cmd As Long, pSendBuf As Any, ByVal SendBufLen As Long, pRecvBuf As Any, ByVal RecvBufLen As Long) As Long

Public Declare Function TSURW_GetTxPower Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Long, ByRef pVal As Long) As Long
Public Declare Function TSURW_SetTxPower Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Long, ByVal Val As Long, ByVal bPermanent As Long ) As Long
Public Declare Function TSURW_ReadRegister Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Long, ByVal Register As Long, ByRef pVal As Long) As Long
Public Declare Function TSURW_WriteRegister Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Long, ByVal Register As Long, ByVal Val As Long) As Long
Public Declare Function TSURW_WriteRegister3 Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Long, ByVal Register As Long, ByVal Val As Long) As Long

Public Declare Function TSURW_Inventory Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Long, ByVal nInventoryType As Long, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSURW_InventoryRSSI Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Long, ByVal nInventoryType As Long, Buffer As Any, ByVal BufLen As Long) As Long

Public Declare Function TSURW_ReadData Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Long, ByVal MemType As Long, ByVal nStartByte As Long, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSURW_ReadAllData Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Long, ByVal MemType As Long, ByVal nStartByte As Long, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSURW_ReadDataPW Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Long, ByVal MemType As Long, ByVal nStartByte As Long, Password As Any, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSURW_ReadAllDataPW Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Long, ByVal MemType  As Long, ByVal nStartWort  As Long, Password As Any, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSURW_WriteData Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Long, ByVal MemType As Long, ByVal nStartByte As Long, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSURW_WriteDataPW Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Long, ByVal MemType As Long, ByVal nStartByte As Long, Password As Any, Buffer As Any, ByVal BufLen As Long) As Long

Public Declare Function TSURW_Select Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Long, ByRef UID As Byte, ByVal UIDLen As Long) As Long

Public Declare Function TSURW_Lock Lib "TS_URW_SDK.DLL" ((ByVal PortHandle As Long, ByVal MemType As Long, ByVal LockType As Long, pPassword As Any) As Long
Public Declare Function TSURW_KillTag Lib "TS_URW_SDK.DLL" ((ByVal PortHandle As Long, ByVal RecomState As Long, pPassword As Any) As Long

Public Declare Function TSURW_WriteParam Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Long, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSURW_ReadParam Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Long, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSURW_WritePrefix Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Long, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSURW_ReadPrefix Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Long, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSURW_WriteSuffix Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Long, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSURW_ReadSuffix Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Long, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSURW_WriteTermix Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Long, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSURW_ReadTermix Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Long, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSURW_WritePostcode Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Long, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSURW_ReadPostcode Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Long, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSURW_WriteReadModeParam Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Long, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSURW_ReadReadModeParam Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Long, Buffer As Any, ByVal BufLen As Long) As Long
