#if !defined(TS_URW_IMPORT_INCLUDED_)
#define TS_URW_IMPORT_INCLUDED_

// Error codes DLL
#define TSURW_NO_ERROR                    0
#define TSURW_PORT_OEFFNEN                1
#define TSURW_TIMEOUT_UNGUELTIG           2
#define TSURW_PORTHANDLE_UNGUELTIG        3
#define TSURW_TIMEOUT                     4
#define TSURW_BUFFER_ZU_KLEIN             5
#define TSURW_BUFFERGROESSE_FALSCH        6
#define TSURW_KEINE_SENDEDATEN            8
#define TSURW_CHECKSUMMENFEHLER           10
#define TSURW_KEINE_KOMMUNIKATION         11
#define TSURW_CHECKBUFFER_LEER            12
#define TSURW_MODE_UNGUELTIG              13
#define TSURW_BEFEHL_NICHT_ERLAUBT        14 
#define TSURW_BLOCKNR_UNGUELTIG           15

#define TSURW_DC3                         19 //0x13
#define TSURW_DC4                         20 //0x14
#define TSURW_NACK                        21 //0x15
#define TSURW_SYNC                        22 //0x16
#define TSURW_ETB                         23 //0x17
#define TSURW_CANCEL                      24 //0x18
#define TSURW_EM                          25 //0x19

// Error codes Leser
#define TSURW_UNBEKANNTES_KOMMANDO                   TSURW_CANCEL
#define TSURW_DATENANZAHL                            TSURW_DC4
#define TSURW_KOLLISION                              TSURW_ETB
#define TSURW_NO_TAG                                 TSURW_NACK
#define TSURW_NO_VALUE                               TSURW_DC3

// Return Values
#define TSURW_RETVAL_ERROR                -1
#define TSURW_RETVAL_OK                   0

/*EPC Mem Banks */
/** Definition for EPC tag memory bank: reserved */
#define MEM_RES           0x00
/** Definition for EPC tag memory bank: EPC memory */
#define MEM_EPC           0x01
/** Definition for EPC tag memory bank: TID */
#define MEM_TID           0x02
/** Definition for EPC tag memory bank: user */
#define MEM_USER          0x03

// Definition of Inventory types
#define INVENTORY_NEW     0x00
#define INVENTORY_START   0x01
#define INVENTORY_NEXT    0x02
#define INVENTORY_TID     0x03


#ifdef __cplusplus
extern "C"
{
#endif

typedef int (__stdcall * TSURW_TRACEFCT)(int handle, LPCTSTR str);

#ifdef _EXPORT
#define _DECL __declspec(dllexport)
#else
#ifdef _URW_LIB
#define _DECL
#else
#define _DECL __declspec(dllimport)
#endif
#endif

_DECL int __stdcall TSURW_LibVersion(void);
_DECL int __stdcall TSURW_IsVirtualComInstalled(void);

_DECL int __stdcall TSURW_IsDeviceDriverMissing(void);

_DECL int __stdcall TSURW_GetUSBDeviceNames(char* NamenListe, int nBufferSize);
_DECL int __stdcall TSURW_GetUSBDeviceNamesEx(char* NamenListe, int nBufferSize);
_DECL int __stdcall TSURW_GetCOMDeviceNames(char* NamenListe, int nBufferSize);

_DECL int __stdcall TSURW_GetLanDeviceNames(char* NamenListe, int nBufferSize);
_DECL int __stdcall TSURW_GetLanDeviceNamesEx(char* NamenListe, int nBufferSize);

_DECL int __stdcall TSURW_ChangeLanIPAddress(LPCSTR OldAddress, LPCSTR NewAddress, LPCSTR IPMask);
_DECL int __stdcall TSURW_ChangeLanIPAddressEx(LPCSTR OldAddress, LPCSTR NewAddress, LPCSTR IPMask, LPCSTR GatewayAddress);
_DECL int __stdcall TSURW_GetLanIPAddressEx(LPCSTR strName, char * Address, char * IPMask, char * GatewayAddress);
_DECL int __stdcall TSURW_IsLanDeviceAvailable(LPCSTR Address);

_DECL int __stdcall TSURW_LanConfigOpen(LPCSTR strName);
_DECL int __stdcall TSURW_LanConfigGet(int handle, int RecordNr,       BYTE * pData, int Len);
_DECL int __stdcall TSURW_LanConfigSet(int handle, int RecordNr, const BYTE * pData,int Len);
_DECL int __stdcall TSURW_LanConfigClose(int handle,int Reset);

_DECL int __stdcall TSURW_HIDConfigRead(int handle, BYTE * pSendBuf, int SendBufLen,BYTE * pRecvBuf, int RecvBufLen);
_DECL int __stdcall TSURW_HIDConfigWrite(int handle, BYTE * pSendBuf, int SendBufLen);

_DECL int __stdcall TSURW_Open(LPCSTR Name,int Baudrate, int ParityMode, int Timeout);
_DECL int __stdcall TSURW_Close(int handle);
_DECL int __stdcall TSURW_KeepAppActive(int handle,int bActive);

_DECL int __stdcall TSURW_SetTrace(TSURW_TRACEFCT fct);

_DECL int __stdcall TSURW_SetReaderAdresse(int handle,int Adresse);

typedef int(__stdcall* AutoReadCallback)(char * pData, int Len);
_DECL int __stdcall TSURW_StartAutoRead(int handle, int TermChar, AutoReadCallback pAutoReadProc);
_DECL int __stdcall TSURW_StopAutoRead(int handle);

_DECL int __stdcall TSURW_GetDeviceVersion(int handle, char * pDevVer, int VerLen,char * pDevName, int NameLen);
_DECL int __stdcall TSURW_IsUSB(int handle);
_DECL int __stdcall TSURW_SetBaudrate(int handle, int Baudrate, int ParityMode);
_DECL int __stdcall TSURW_SetReaderMode(int handle,int mode);
_DECL int __stdcall TSURW_SetRF(int handle,int OnOff);
_DECL int __stdcall TSURW_SetIO(int handle,int Maske, int OutWert);
_DECL int __stdcall TSURW_ReadIO(int handle);

_DECL int __stdcall TSURW_SetLED(int handle, int red, int green, int yellow);
_DECL int __stdcall TSURW_Beep(int handle);

_DECL int __stdcall TSURW_GetLastError(int handle);

_DECL int __stdcall TSURW_ReadSerialNumber(int handle, BYTE * pSerial, int Buflen);
_DECL int __stdcall TSURW_SetConfig(int handle,BYTE * pConfig, int ConfigLen);
_DECL int __stdcall TSURW_GetConfig(int handle,BYTE * pConfig, int ConfigLen);
_DECL int __stdcall TSURW_SetDefault(int handle);
_DECL int __stdcall TSURW_SetCommunicationMode(int handle, int Mode);

_DECL int __stdcall TSURW_RawWrite      (int handle,BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSURW_RawRead       (int handle,BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSURW_Transfer      (int handle, int Cmd, BYTE * pSendBuf, int SendBufLen,BYTE * pRecvBuf, int RecvBufLen);

_DECL int __stdcall TSURW_GetTxPower    (int handle, int* pVal);
_DECL int __stdcall TSURW_SetTxPower    (int handle, int Val, int bPermanent);
_DECL int __stdcall TSURW_ReadRegister  (int handle, int Register, int *pVal);
_DECL int __stdcall TSURW_WriteRegister (int handle, int Register, int Val);
_DECL int __stdcall TSURW_WriteRegister3(int handle, int Register, int Val);

_DECL int __stdcall TSURW_Inventory     (int handle, int nInventoryType, BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSURW_InventoryRSSI (int handle, int nInventoryType, BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSURW_ReadData      (int handle, int MemType, int nStartByte, BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSURW_ReadAllData   (int handle, int MemType, int nStartByte, BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSURW_ReadDataPW    (int handle, int MemType, int nStartByte, BYTE * pPassword, BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSURW_ReadAllDataPW (int handle, int MemType, int nStartWort, BYTE* pPassword, BYTE* pBuffer, int BufLen);
_DECL int __stdcall TSURW_WriteData     (int handle, int MemType, int nStartByte, BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSURW_WriteDataPW   (int handle, int MemType, int nStartByte, BYTE * pPassword, BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSURW_Select        (int handle, BYTE * pUID, int UIDLen);
_DECL int __stdcall TSURW_Lock          (int handle, int MemType, int LockType, BYTE * pPassword);
_DECL int __stdcall TSURW_KillTag       (int handle, int RecomState, BYTE * pPassword);

_DECL int __stdcall TSURW_WriteParam    (int handle, BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSURW_ReadParam     (int handle, BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSURW_WritePrefix   (int handle, BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSURW_ReadPrefix    (int handle, BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSURW_WriteSuffix   (int handle, BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSURW_ReadSuffix    (int handle, BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSURW_WriteTermix   (int handle, BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSURW_ReadTermix    (int handle, BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSURW_WritePostcode (int handle, BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSURW_ReadPostcode  (int handle, BYTE * pBuffer, int BufLen);

_DECL int __stdcall TSURW_WriteReadModeParam(int handle, BYTE * pBuffer, int BufLen);
_DECL int __stdcall TSURW_ReadReadModeParam (int handle, BYTE * pBuffer, int BufLen);

#ifdef __cplusplus
}
#endif

#endif // TS_URW_IMPORT_INCLUDED_
