Imports System.Runtime.InteropServices

Public Module [Lib]
  'Option Explicit

  'Fehlerliste  Dll Funktionsaufrufe
  Public Const TSURW_NO_ERROR = 0
  Public Const TSURW_PORT_OEFFNEN = 1
  Public Const TSURW_TIMEOUT_UNGUELTIG = 2
  Public Const TSURW_PORTHANDLE_UNGUELTIG = 3
  Public Const TSURW_TIMEOUT = 4
  Public Const TSURW_BUFFER_ZU_KLEIN = 5
  Public Const TSURW_BUFFERGROESSE_FALSCH = 6
  Public Const TSURW_KEINE_SENDEDATEN = 8
  Public Const TSURW_CHECKSUMMENFEHLER = 10
  Public Const TSURW_KEINE_KOMMUNIKATION = 11
  Public Const TSURW_CHECKBUFFER_LEER = 12
  Public Const TSURW_MODE_UNGUELTIG = 13
  Public Const TSURW_BEFEHL_NICHT_ERLAUBT = 14
  Public Const TSURW_BLOCKNR_UNGUELTIG = 15
  Public Const TSURW_NO_VALUE = 19
  Public Const TSURW_DATENANZAHL = 20
  Public Const TSURW_NO_TAG = 21
  Public Const TSURW_KOLLISION = 23
  Public Const TSURW_UNBEKANNTES_KOMMANDO = 24

  'Leserfehler
  Public Const TSURW_NACK = 21
  Public Const TSURW_SYNC = 22
  Public Const TSURW_CANCEL = 24

  'Rckgabewerte
  Public Const TSURW_RETVAL_ERROR = -1
  Public Const TSURW_RETVAL_OK = 0

  'EPC Mem Banks 
  'Definition for EPC tag memory bank: reserved 
  Public Const MEM_RES = 0
  ' Definition for EPC tag memory bank: EPC memory 
  Public Const MEM_EPC = 1
  ' Definition for EPC tag memory bank: TID 
  Public Const MEM_TID = 2
  ' Definition for EPC tag memory bank: user 
  Public Const MEM_USER = 3

  ' Definition der Inventorytypen
  Public Const INVENTORY_NEW = 0
  Public Const INVENTORY_START = 1
  Public Const INVENTORY_NEXT = 2
  Public Const INVENTORY_TID  = 3

  '// Get Library Version
  Public Declare Function TSURW_LibVersion Lib "TS_URW_SDK.DLL" () As Integer

  Public Declare Function TSURW_IsVirtualComInstalled Lib "TS_URW_SDK.DLL" () As Integer

  '// Get Names of all USB Devices connected, only valid devices are listed
  Public Declare Function TSURW_GetUSBDeviceNames Lib "TS_URW_SDK.DLL" (<Out()> ByRef Buffer As Byte, ByVal nBufferSize As Integer) As Integer

  '// Get Names of all USB Devices connected, all devices from GiS are listed
  Public Declare Function TSURW_GetUSBDeviceNamesEx Lib "TS_URW_SDK.DLL" (<Out()> ByRef Buffer As Byte, ByVal nBufferSize As Integer) As Integer

  '// Get Names of all COM Ports available, not tested if there is a device at the port connected.
  Public Declare Function TSURW_GetCOMDeviceNames Lib "TS_URW_SDK.DLL" (<Out()> ByRef Buffer As Byte, ByVal nBufferSize As Integer) As Integer

  '// Get Names of all valid LAN devices found in same subnet
  Public Declare Function TSURW_GetLanDeviceNames Lib "TS_URW_SDK.DLL" (<Out()> ByRef Buffer As Byte, ByVal nBufferSize As Integer) As Integer

  '// Get Names of all LAN devices found even in other subnets
  Public Declare Function TSURW_GetLanDeviceNamesEx Lib "TS_URW_SDK.DLL" (<Out()> ByRef Buffer As Byte, ByVal nBufferSize As Integer) As Integer

  '// Change IP Address of LAN device
  Public Declare Function TSURW_ChangeLanIPAddress Lib "TS_URW_SDK.DLL" (<[In]()> ByRef OldAddress As Byte, <[In]()> ByRef NewAddress As Byte, <[In]()> IPMask As Byte) As Integer

  '// Change IP Address and Gateway of LAN device
  Public Declare Function TSURW_ChangeLanIPAddressEx Lib "TS_URW_SDK.DLL" (<[In]()> ByRef OldAddress As Byte, <[In]()> ByRef NewAddress As Byte, <[In]()> IPMask As Byte, <[In]()> Gateway As Byte) As Integer

  '// Get IP Address and Gateway of LAN device
  Public Declare Function TSURW_GetLanIPAddressEx Lib "TS_URW_SDK.DLL" (<[In]()> ByRef strName As Byte, <Out()> ByRef Address As Byte, <Out()> ByRef IPMask As Byte, <Out()> ByRef GatewayAddress As Byte) As Integer

  '// Check if specific LAN device is available
  Public Declare Function TSURW_IsLanDeviceAvailable Lib "TS_URW_SDK.DLL" (<[In]()> ByRef Address As Byte) As Integer

  '// Open LAN Device for configuration
  Public Declare Function TSURW_LanConfigOpen Lib "TS_URW_SDK.DLL" (<[In]()> ByRef strName As Byte) As Integer

  '// Set Configuration Record of LAN device, use with care!
  Public Declare Function TSURW_LanConfigGet Lib "TS_URW_SDK.DLL" (ByVal nHandle As Integer, ByVal RecordNr As Integer, <Out()> ByRef pData As Byte, ByVal DatLen As Integer) As Integer

  '// Get Configuration Record of LAN device
  Public Declare Function TSURW_LanConfigSet Lib "TS_URW_SDK.DLL" (ByVal nHandle As Integer, ByVal RecordNr As Integer, <[In]()> ByRef pData As Byte, ByVal DatLen As Integer) As Integer

  '// Close LAN device configuration.
  Public Declare Function TSURW_LanConfigClose Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Integer, ByVal Reset As Integer) As Integer

  '// Read Configuration of USB HID device
  Public Declare Function TSURW_HIDConfigRead Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Integer, <[In]()> ByRef pSendBuf As Byte, ByVal SendBufLen As Integer, <Out()> ByRef pRecvBuf As Byte, ByVal RecvBufLen As Integer) As Integer
  '// Write Configuration to USB HID device
  Public Declare Function TSURW_HIDConfigWrite Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Integer, <[In]()> ByRef pSendBuf As Byte, ByVal SendBufLen As Integer) As Integer

  Public Declare Function TSURW_Open Lib "TS_URW_SDK.DLL" (<[In]()> ByRef Name As Byte, ByVal Baudrate As Integer, ByVal ParityMode As Integer, ByVal Timeout As Integer) As Integer

  Public Declare Function TSURW_Close Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Integer) As Integer

  Public Declare Function TSURW_KeepAppActive Lib "TS_URW_SDK.DLL" (ByVal handle As Integer, ByVal bActive As Integer) As Integer

  Public Declare Function TSURW_SetReaderAdresse Lib "TS_URW_SDK.DLL" (ByVal handle As Integer, ByVal Adresse As Integer) As Integer

  Public Delegate Function AutoReadCallback (<MarshalAs(UnmanagedType.LPStr)> Arr As String, ByVal Len As Integer) As Integer 

  Public Declare Function TSURW_StartAutoRead Lib "TS_URW_SDK.DLL" (ByVal handle As Integer, ByVal TermChar As Integer, pAutoReadProc As AutoReadCallback) As Integer
  Public Declare Function TSURW_StopAutoRead Lib "TS_URW_SDK.DLL" (ByVal handle As Integer) As Integer

  Public Declare Function TSURW_GetDeviceVersion Lib "TS_URW_SDK.DLL" (ByVal handle As Integer, <Out()> ByRef pDevVer As Byte, ByVal VerLen As Integer, <Out()> ByRef pDevName As Byte, ByVal NameLen As Integer) As Integer

  Public Declare Function TSURW_IsUSB Lib "TS_URW_SDK.DLL" (ByVal handle As Integer) As Integer

  Public Declare Function TSURW_SetBaudrate Lib "TS_URW_SDK.DLL" (ByVal handle As Integer, ByVal Baudrate As Integer, ByVal ParityMode As Integer) As Integer

  Public Declare Function TSURW_SetReaderMode Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Integer, ByVal Mode As Integer) As Integer

  Public Declare Function TSURW_SetRF Lib "TS_URW_SDK.DLL" (ByVal handle As Integer, ByVal OnOff As Integer) As Integer

  Public Declare Function TSURW_GetLastError Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Integer) As Integer

  Public Declare Function TSURW_SetIO Lib "TS_URW_SDK.DLL" (ByVal handle As Integer, ByVal Maske As Integer, ByVal Daten As Integer) As Integer
  Public Declare Function TSURW_ReadIO Lib "TS_URW_SDK.DLL" (ByVal handle As Integer, <Out()> ByRef pDaten As Integer) As Integer

  Public Declare Function TSURW_SetLED Lib "TS_URW_SDK.DLL" (ByVal handle As Integer, ByVal red As Integer, ByVal green As Integer, ByVal yellow As Integer) As Integer
  Public Declare Function TSURW_Beep Lib "TS_URW_SDK.DLL" (ByVal handle As Integer) As Integer

  Public Declare Function TSURW_ReadSerialNumber Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Integer, <Out()> ByRef pSerial As Byte, ByVal BufLen As Integer) As Integer

  Public Declare Function TSURW_SetConfig Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Integer, <[In]()> ByRef pConfig As Byte, ByVal ConfigLen As Integer) As Integer
  Public Declare Function TSURW_GetConfig Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Integer, <Out()> ByRef pConfig As Byte, ByVal ConfigLen As Integer) As Integer

  Public Declare Function TSURW_SetDefault Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Integer) As Integer

  Public Declare Function TSURW_SetCommunicationMode Lib "TS_URW_SDK.DLL" (ByVal handle As Integer, ByVal Mode As Integer) As Integer

  Public Declare Function TSURW_RawRead Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Integer, <Out()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSURW_RawWrite Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Integer, <[In]()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSURW_Transfer Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Integer, ByVal Cmd As Integer, pSendBuf As Byte, ByVal SendBufLen As Integer, <Out()> ByRef pRecvBuf As Byte, ByVal RecvBufLen As Integer) As Integer

	Public Declare Function TSURW_GetTxPower Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Integer, <Out()> ByRef pVal As Integer) As Integer
	Public Declare Function TSURW_SetTxPower Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Integer, ByVal Val As Integer, ByVal bPermanent As Integer ) As Integer
  Public Declare Function TSURW_ReadRegister Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Integer, ByVal Register As Integer, <Out()> ByRef pVal As Integer) As Integer
  Public Declare Function TSURW_WriteRegister Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Integer, ByVal Register As Integer, ByVal Val As Integer) As Integer
  Public Declare Function TSURW_WriteRegister3 Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Integer, ByVal Register As Integer, ByVal Val As Integer) As Integer

  Public Declare Function TSURW_Inventory Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Integer, ByVal nInventoryType As Integer, <Out()> ByRef pBuffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSURW_InventoryRSSI Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Integer, ByVal nInventoryType As Integer, <Out()> ByRef pBuffer As Byte, ByVal BufLen As Integer) As Integer

  Public Declare Function TSURW_ReadData Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Integer, ByVal MemType As Integer, ByVal nStartByte As Integer, <Out()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSURW_ReadAllData Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Integer, ByVal MemType As Integer, ByVal nStartByte As Integer, <Out()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSURW_ReadDataPW Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Integer, ByVal MemType As Integer, ByVal nStartByte As Integer, <[In]()> ByRef Password As Byte, <Out()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
	Public Declare Function TSURW_ReadAllDataPW Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Integer, ByVal MemType  As Integer, ByVal nStartWort  As Integer, <[In]()> ByRef Password As Byte, <Out()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer

  Public Declare Function TSURW_WriteData Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Integer, ByVal MemType As Integer, ByVal nStartByte As Integer, <[In]()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSURW_WriteDataPW Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Integer, ByVal MemType As Integer, ByVal nStartByte As Integer, <[In]()> ByRef Password As Byte, <[In]()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer

  Public Declare Function TSURW_Select Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Integer, <[In]()> ByRef UID As Byte, ByVal UIDLen As Integer) As Integer

  Public Declare Function TSURW_Lock Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Integer, ByVal MemType As Integer, ByVal LockType As Integer, <[In]()> ByRef pPassword As Byte) As Integer
  Public Declare Function TSURW_KillTag Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Integer, ByVal RecomState As Integer, <[In]()> ByRef pPassword As Byte) As Integer

  Public Declare Function TSURW_WriteParam Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Integer, <[In]()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSURW_ReadParam Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Integer, <Out()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSURW_WritePrefix Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Integer, <[In]()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSURW_ReadPrefix Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Integer, <Out()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSURW_WriteSuffix Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Integer, <[In]()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSURW_ReadSuffix Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Integer, <Out()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSURW_WriteTermix Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Integer, <[In]()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSURW_ReadTermix Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Integer, <Out()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSURW_WritePostcode Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Integer, <[In]()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSURW_ReadPostcode Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Integer, <Out()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSURW_WriteReadModeParam Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Integer, <[In]()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer
  Public Declare Function TSURW_ReadReadModeParam Lib "TS_URW_SDK.DLL" (ByVal PortHandle As Integer, <Out()> ByRef Buffer As Byte, ByVal BufLen As Integer) As Integer

End Module
