
// TS_URW_InventoryVCDlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "TS_URW_InventoryVC.h"
#include "TS_URW_InventoryVCDlg.h"
#include "afxdialogex.h"

#include "..\..\TS_URW_Import.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg-Dialogfeld fr Anwendungsbefehl "Info"

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Dialogfelddaten
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung

// Implementierung
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CTS_URW_InventoryVCDlg-Dialogfeld



CTS_URW_InventoryVCDlg::CTS_URW_InventoryVCDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CTS_URW_InventoryVCDlg::IDD, pParent)
  , m_Inventory(_T(""))
  , m_DeviceName(_T(""))
{
  m_myHandle = 0;
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
  m_bURW39 = false;
}

int ToVer(char cVer)
{
  if (cVer >= '0' && cVer <= '9')
     return cVer - '0';
  if (cVer >= 'A' && cVer <= 'Z')
     return cVer - 'A' + 10;
  if (cVer >= 'a' && cVer <= 'z')
     return cVer - 'a' + 10 + 26;
  return 99;
}

bool CTS_URW_InventoryVCDlg::OpenIfNeeded()
{
  if (m_myHandle > 0)
  {
    // Device already opened
    return true;
  }

  m_bURW39 = false;
  m_DeviceName.Empty();
  SetDlgItemText(IDC_DEVICENAME,m_DeviceName);

  if (m_DeviceList.GetCurSel() < 0)
    return false;

  CString DeviceName;
  m_DeviceList.GetText(m_DeviceList.GetCurSel(),DeviceName);
  if (DeviceName.GetLength() > 0)
  {
    char DeviceNameArr[100];
    MakeArrayFromString(DeviceNameArr, DeviceName);

    m_myHandle = TSURW_Open(DeviceNameArr, 19200, 0, 500);
    if (m_myHandle > 0)
    {
      char DevVer[10];
      char DevName[50];
      if (TSURW_GetDeviceVersion(m_myHandle,DevVer,sizeof(DevVer),DevName,sizeof(DevName)) > 0)
      {
        m_bURW39 = (DevVer[0] == '3') && (DevVer[1] == '1');
        m_DeviceName.Format(_T("%s (V1.%02d)"),CString(DevName),ToVer(DevVer[3]));
        SetDlgItemText(IDC_DEVICENAME,m_DeviceName);
        return true;
      }
    }
  }
  return false;
}

void CTS_URW_InventoryVCDlg::CloseIfOpen()
{
  if (m_myHandle > 0)
    TSURW_Close(m_myHandle);
  m_myHandle = 0;
  m_DeviceName.Empty();
  SetDlgItemText(IDC_DEVICENAME,m_DeviceName);
}

CString CTS_URW_InventoryVCDlg::MakeStringFromArray(char Arr[], int ArrLength, int &StartIdx)
{
  CString strLine;
  strLine = "";
  int i;
  for (i = StartIdx; (i < ArrLength) && (Arr[i] != 0); i++)
  {
    strLine += (char)Arr[i];
  }
  i++;
  StartIdx = i;
  return strLine;
}

CString CTS_URW_InventoryVCDlg::MakeStringFromData(byte Arr[], int StartIdx, int EndIdx)
{
  CString strLine;
  CString item;
  strLine = "";
  int i;
  for (i = StartIdx; (i <= EndIdx); i++)
  {
    item.Format(_T("%02X"), Arr[i]);
    strLine += item;
    strLine += " ";
  }
  StartIdx = i;
  return strLine;
}

int CTS_URW_InventoryVCDlg::MakeArrayFromString(char Arr[], CString str)
{
  int i;
  for (i = 0; i < str.GetLength(); i++)
    Arr[i] = (char)str[i];
  Arr[i] = 0;
  return i;
}

static byte ASCII2Hex(TCHAR ch)
{
  if ((ch >= '0') && (ch <= '9'))
    return ch - '0';
  else if ((ch >= 'A') && (ch <= 'F'))
    return ch - 'A' + 10;
  else if ((ch >= 'a') && (ch <= 'f'))
    return ch - 'a' + 10;
  return 0;
}

byte CTS_URW_InventoryVCDlg::MakeHex(TCHAR high, TCHAR low)
{
  return ASCII2Hex(high)<<4 | ASCII2Hex(low);
}

int CTS_URW_InventoryVCDlg::MakeDataFromString(byte Arr[], int ArrLength, CString str)
{
  int i;
  int s1, s2;

  str.TrimLeft(' ');
  str.TrimRight(' ');
  s1 = 0; s2 = 0; i = 0;

  while ((i <= ArrLength) && (s2<str.GetLength()))
  {
    s1 = s2;
    while ((s2 < s1 + 2) && (s2<str.GetLength()))
    {
      if (str[s2] == ' ')
        break;
      s2++;
    }
    if (s2 == s1 + 2)
      Arr[i++] = MakeHex(str[s1], str[s1 + 1]);
    else
      Arr[i++] = MakeHex(str[s1], '0');
    while ((s2<str.GetLength()) && (str[s2] == ' '))
      s2++;
  }
  return i;
}

void CTS_URW_InventoryVCDlg::DoDataExchange(CDataExchange* pDX)
{
  CDialogEx::DoDataExchange(pDX);
  DDX_Control(pDX, IDC_DEVICE_LIST, m_DeviceList);
  DDX_Control(pDX, IDC_STATUS, m_StatusCtrl);
  DDX_Control(pDX, IDC_INVENTORY_LIST, m_InventoryList);
  DDX_Text(pDX, IDC_DEVICENAME, m_DeviceName);
}

BEGIN_MESSAGE_MAP(CTS_URW_InventoryVCDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
  ON_BN_CLICKED(IDC_READ_INVENTORY, &CTS_URW_InventoryVCDlg::OnReadInventory)
  ON_BN_CLICKED(IDC_SCAN, &CTS_URW_InventoryVCDlg::OnScan)
  ON_BN_CLICKED(IDC_READ_INVENTORY_RSSI, &CTS_URW_InventoryVCDlg::OnReadInventoryRssi)
  ON_LBN_SELCHANGE(IDC_DEVICE_LIST, &CTS_URW_InventoryVCDlg::OnSelchangeDeviceList)
  ON_WM_GETMINMAXINFO()
END_MESSAGE_MAP()


// CTS_URW_InventoryVCDlg-Meldungshandler

BOOL CTS_URW_InventoryVCDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Hinzufgen des Menbefehls "Info..." zum Systemmen.

	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Symbol fr dieses Dialogfeld festlegen.  Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden

  CRect r;
  GetWindowRect(r);
  m_MinSize = r.Size(); 

	return TRUE;  // TRUE zurckgeben, wenn der Fokus nicht auf ein Steuerelement gesetzt wird
}

void CTS_URW_InventoryVCDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// Wenn Sie dem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie
//  den nachstehenden Code, um das Symbol zu zeichnen.  Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch ausgefhrt.

void CTS_URW_InventoryVCDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext zum Zeichnen

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Symbol in Clientrechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// Die System ruft diese Funktion auf, um den Cursor abzufragen, der angezeigt wird, whrend der Benutzer
//  das minimierte Fenster mit der Maus zieht.
HCURSOR CTS_URW_InventoryVCDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



BOOL CTS_URW_InventoryVCDlg::DestroyWindow()
{
  CloseIfOpen();

  return CDialogEx::DestroyWindow();
}


void CTS_URW_InventoryVCDlg::OnScan()
{
    int MaxLen = 255;
    int ListLen = 0;
    char NamenListe[255];

    CloseIfOpen();

    m_DeviceList.ResetContent();
    ListLen = TSURW_GetUSBDeviceNames(NamenListe, MaxLen);

    if (ListLen > 1)
    {
      int StartIdx = 0;
      CString Name;
      do
      {
        Name = MakeStringFromArray(NamenListe, ListLen, StartIdx);
        if (Name.GetLength() > 0)
          m_DeviceList.AddString(Name);
      }
      while (Name.GetLength() > 0);
    }

    ListLen = TSURW_GetCOMDeviceNames(NamenListe, MaxLen);
    if (ListLen > 1)
    {
      int StartIdx = 0;
      CString Name;
      do
      {
        Name = MakeStringFromArray(NamenListe, ListLen, StartIdx);
        if (Name.GetLength() > 0)
          m_DeviceList.AddString(Name);
      }
      while (Name.GetLength() > 0);
    }
    if (m_DeviceList.GetCount() > 0)
      m_DeviceList.SetCurSel(0);
}

static void DeleteAllColumns(CListCtrl &List)
{
  int nColumnCount = List.GetHeaderCtrl()->GetItemCount();
  // Delete all of the columns. 
  for (int i=0; i < nColumnCount; i++)
  {
    List.DeleteColumn(0);
  }
}

void CTS_URW_InventoryVCDlg::OnReadInventory()
{
  if (OpenIfNeeded())
  {
    int UsedLen;
    byte Buffer[100];
    DeleteAllColumns(m_InventoryList);

    m_InventoryList.DeleteAllItems();

    m_InventoryList.InsertColumn(0,_T("EPC"),LVCFMT_LEFT,400,0);

    UsedLen = TSURW_Inventory(m_myHandle, INVENTORY_NEW, Buffer, sizeof(Buffer));
    if (UsedLen > 0)
    {
      // 1st Byte is number of tags
      BYTE TagCount = Buffer[0];
      int idx = 0;
      if (TagCount > 0)
      {
        m_Inventory = MakeStringFromData(Buffer, 3, UsedLen-1);
        m_InventoryList.InsertItem(idx++,m_Inventory);
        while (TagCount > 1)
        {
          UsedLen = TSURW_Inventory(m_myHandle,INVENTORY_NEXT,Buffer,sizeof(Buffer));
          if (UsedLen < 0)
            break;
          // 1st Byte is number of tags
          TagCount = Buffer[0];
          m_Inventory = MakeStringFromData(Buffer, 3, UsedLen-1);
          m_InventoryList.InsertItem(idx++,m_Inventory);
        } 
      }
    }
  }
  UpdateData(FALSE);
}

double CalcRSSI(int rssi_i,int rssi_q,int gain_i,int gain_q)
{
  double rfin_i1 = 20*log10(rssi_i) - gain_i - 63;
  double rfin_q1 = 20*log10(rssi_q) - gain_q - 63;
  double rfin_i2 = pow(10,rfin_i1/20);
  double rfin_q2 = pow(10,rfin_q1/20);
  double rfin = sqrt(rfin_i2*rfin_i2 + rfin_q2*rfin_q2);
  return 20*log10(rfin);
}

int FindInsertPoint(CListCtrl &List,CString rssi)
{
  int items = List.GetItemCount();
  double frssi = _ttof(rssi);
  for (int i = 0; i < items; i++)
  {
    double fItem = _ttof(List.GetItemText(i,1));
    if (fItem < frssi)
      return i;
  }
  return items;
}

void CTS_URW_InventoryVCDlg::OnReadInventoryRssi()
{
  if (OpenIfNeeded())
  {
    CString strRSSI;
    CString strFrequenz;
    int UsedLen;
    byte Buffer[100];
    DeleteAllColumns(m_InventoryList);

    m_InventoryList.DeleteAllItems();

    m_InventoryList.InsertColumn(0,_T("EPC"),LVCFMT_LEFT,360,0);
    if (m_bURW39)
    {
      m_InventoryList.InsertColumn(1, _T("RSSI (dBm)"), LVCFMT_LEFT, 150, 1);
    }
    else
    {
      m_InventoryList.InsertColumn(1,_T("Freq. (MHz)"),LVCFMT_LEFT,120,1);
      m_InventoryList.InsertColumn(2,_T("RSSI"),LVCFMT_LEFT,100,2);
    }
    // Read Inventory with RSSI, last four bytes of answer are RSSI Values.
    UsedLen = TSURW_InventoryRSSI(m_myHandle, INVENTORY_NEW, Buffer, sizeof(Buffer));
    if (UsedLen > 0)
    {
      // 1st Byte is number of tags
      BYTE TagCount = Buffer[0];
      int idx = 0;
      if (TagCount > 0)
      {
        m_Inventory = MakeStringFromData(Buffer, 3, UsedLen-5); // Skip last bytes from Answer, because these ar not EPC
        if (m_bURW39)
        {
          // RSSI Calculation from Result given by URW39 
          strRSSI.Format(_T("%.3f"),CalcRSSI(Buffer[UsedLen-4],Buffer[UsedLen-3],Buffer[UsedLen-2],Buffer[UsedLen-1]));
          m_InventoryList.InsertItem(idx, m_Inventory);
          m_InventoryList.SetItemText(idx,1,strRSSI);
        }
        else
        {
          // RSSI Calculation from Result given by URW38,
          // Calculation of dBm not possible, so raw data is shown.
          int RSSI = Buffer[UsedLen-4];
          int Frequenz = MAKELONG(MAKEWORD(Buffer[UsedLen-3],Buffer[UsedLen-2]),MAKEWORD(Buffer[UsedLen-1],0));
          strFrequenz.Format(_T("%.3f"), Frequenz / 1000.);
          strRSSI.Format(_T("I:%d Q:%d"),(RSSI&0x0f),((RSSI>>4)&0x0f));
          m_InventoryList.InsertItem(idx, m_Inventory);
          m_InventoryList.SetItemText(idx,1,strFrequenz);
          m_InventoryList.SetItemText(idx,2,strRSSI);
        }
        idx++;

        while (TagCount > 1)
        {
          UsedLen = TSURW_InventoryRSSI(m_myHandle,INVENTORY_NEXT,Buffer,sizeof(Buffer));
          if (UsedLen < 0)
            break;
          // 1st Byte is number of tags
          TagCount = Buffer[0];
          m_Inventory = MakeStringFromData(Buffer, 3, UsedLen-5);
          if (m_bURW39)
          {
            // RSSI Calculation from Result given by URW39 
            strRSSI.Format(_T("%.3f"),CalcRSSI(Buffer[UsedLen-4],Buffer[UsedLen-3],Buffer[UsedLen-2],Buffer[UsedLen-1]));
            idx = FindInsertPoint(m_InventoryList,strRSSI);
            m_InventoryList.InsertItem(idx, m_Inventory);
            m_InventoryList.SetItemText(idx,1,strRSSI);
          }
          else
          {
            // RSSI Calculation from Result given by URW38,
            // Calculation of dBm not possible, so raw data is shown.
            int RSSI = Buffer[UsedLen-4];
            int Frequenz = MAKELONG(MAKEWORD(Buffer[UsedLen-3],Buffer[UsedLen-2]),MAKEWORD(Buffer[UsedLen-1],0));
            strFrequenz.Format(_T("%.3f"), Frequenz / 1000.);
            strRSSI.Format(_T("I:%d Q:%d"),(RSSI&0x0f),((RSSI>>4)&0x0f));
            m_InventoryList.InsertItem(idx, m_Inventory);
            m_InventoryList.SetItemText(idx,1,strFrequenz);
            m_InventoryList.SetItemText(idx,2,strRSSI);
          }
          idx++;
        } 
      }
    }
  }
  UpdateData(FALSE);
}


void CTS_URW_InventoryVCDlg::OnSelchangeDeviceList()
{
  CloseIfOpen();
}


void CTS_URW_InventoryVCDlg::OnGetMinMaxInfo(MINMAXINFO* lpMMI)
{
  lpMMI->ptMinTrackSize = m_MinSize;
  CDialogEx::OnGetMinMaxInfo(lpMMI);
}
